#define _GNU_SOURCE

#include <stdio.h>
#include <sys/mount.h>
#include <systemd/sd-daemon.h>
#include <unistd.h>
#include <sched.h>
#include <sys/stat.h>

int main() {
    int err = unshare(CLONE_NEWNET);
    if (err) {
        perror("Error");
        return 1;
    }

    err = mkdir("/run/vpn", 0755);
    if (err) {
        perror("Error");
    }

    char mount_path[32] = {0};
    snprintf(mount_path, sizeof(mount_path), "/proc/%d/ns", getpid());

    err = mount(mount_path, "/run/vpn", NULL, MS_BIND, NULL);
    if (err) {
        perror("Error");
        return 1;
    }
    sd_notify(0, "READY=1");
    while (1) {
        sleep(10);
    }
    return 1;
}
